Welcome to the Treehouse Community

The Treehouse Community is a meeting place for developers, designers, and programmers of all backgrounds and skill levels to get support. Collaborate here on code errors or bugs that you need feedback on, or asking for an extra set of eyes on your latest project. Join thousands of Treehouse students and alumni in the community today. (Note: Only Treehouse students can comment or ask questions, but non-students are welcome to browse our conversations.)

Looking to learn something new?

Treehouse offers a seven day free trial for new students. Get access to thousands of hours of content and a supportive community. Start your free trial today.

Python Python Basics Functions and Looping Raising Exceptions

Please help me

def split_check (total, number):
    if number <=1:
        raise ValueError("Need more than 1 person")
    if total <=0:
        raise ValueError("the money must be more than $0")
    return (total/number)

try:
    total = float(input("What is the total?"))
    number = int(input("how many people?"))
    amount_due = split_check (total,number)
except ValueError as err:
    print ("not a valid value")
    print("({})".format(err))
else:
    print ("Each person owes ${}".format(amount_due))

So when I enter -200 for the total and 0 for the number, it only prints out the line "Need more than 1 person" and it doesn't print out the "the money must be more than $0".

What should I do if I want both of them to show up? Thanks.

1 Answer

Steven Parker
Steven Parker
215,954 Points

One way would be to check for the 2nd condition within the first conditional:

def split_check (total, number):
    if number <=1:
        if total <=0:
            raise ValueError("Need more than 1 person and the money must be more than $0")
        raise ValueError("Need more than 1 person")
    if total <=0:
        raise ValueError("the money must be more than $0")
    return (total/number)

Thank you :D